function methods = admMethods(adopts)
  methods = struct('name', {'fun', ...
                      'For/O(o)', 'For/O(a)', 'For/O(a2)', 'For/D', 'For/V', ...
                      'VFor', 'VFor/V', ...
                      'Rev/O(o)', 'Rev/O(a)', 'Rev/O(a2)', 'Rev/D', 'Rev/V', ...
                      'FD', 'FD/V', 'CS', 'CS/V', ...
                      'HRev(a)', 'HRev(a2)', 'HFor2/O', 'HFor2/D', 'HFor(a)', 'HFor(a2)', 'HVFor', 'HFD', ...
                      'HRev/V', 'HFor/V', 'HVFor/V', 'HFD/V'
                   }, ...
                 'desc', 'unknown', ...
                 'derivtype', {'f', ...
                      'J', 'J', 'J', 'J', 'Jv', ...
                      'J', 'Jv', ...
                      'J', 'J', 'J', 'J', 'Jv', ...
                      'J', 'Jv', 'J', 'Jv', ...
                      'H', 'H', 'H', 'H', 'H', 'H', 'H', 'H', ...
                      'Hv', 'Hv', 'Hv', 'Hv'
                   }, ...
                 'derivtech', {'', ...
                      'AD', 'AD', 'AD', 'AD', 'AD', ...
                      'AD', 'AD', ...
                      'AD', 'AD', 'AD', 'AD', 'AD', ...
                      'FD', 'FD', 'CS', 'CS', ...
                      'AD', 'AD', 'AD', 'AD', 'AD', 'AD', 'AD', 'FD', ...
                      'AD', 'AD', 'AD', 'FD'
                   }, ...
                 'isvec', { false, ...
                      false, false, false, false, true, ...
                      false, true, ...
                      false, false, false, false, true, ...
                      false, true, false, true, ...
                      false, false, false, false, false, false, false, false, ...
                      true, true, true, true} ...
                 );

  if nargin < 1
    adopts = admOptions();
  end

  if isfield(adopts, 'x_derivtypes')
    derivtypes = adopts.x_derivtypes;
  else
    derivtypes = {'H', 'Hv', 'J', 'Jv', 'f'};
  end
  
  if isfield(adopts, 'x_derivtechs')
    derivtechs = adopts.x_derivtechs;
  else
    derivtechs = {'AD', 'FD', 'CS'};
  end
  
  derivtypesel = arrayfun(@(x) any(strcmp(x.derivtype, derivtypes)), methods);
  methods = methods(derivtypesel);
  
  methsel = arrayfun(@(x) any(strcmp(x.derivtech, derivtechs)) || isempty(x.derivtech), methods);
  methods = methods(methsel);
