% Generated by ADiMat 0.6.0-4788
% © 2001-2008 Andre Vehreschild <vehreschild@sc.rwth-aachen.de>
% © 2009-2013 Johannes Willkomm <johannes.willkomm@sc.tu-darmstadt.de>
% RWTH Aachen University, 52056 Aachen, Germany
% TU Darmstadt, 64289 Darmstadt, Germany
% Visit us on the web at http://www.adimat.de/
% Report bugs to adimat-users@lists.sc.informatik.tu-darmstadt.de
%
%                             DISCLAIMER
% 
% ADiMat was prepared as part of an employment at the Institute for Scientific Computing,
% RWTH Aachen University, Germany and at the Institute for Scientific Computing,
% TU Darmstadt, Germany and is provided AS IS. 
% NEITHER THE AUTHOR(S), THE GOVERNMENT OF THE FEDERAL REPUBLIC OF GERMANY
% NOR ANY AGENCY THEREOF, NOR THE RWTH AACHEN UNIVERSITY, NOT THE TU DARMSTADT,
% INCLUDING ANY OF THEIR EMPLOYEES OR OFFICERS, MAKES ANY WARRANTY, EXPRESS OR IMPLIED,
% OR ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY, COMPLETENESS,
% OR USEFULNESS OF ANY INFORMATION OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE
% WOULD NOT INFRINGE PRIVATELY OWNED RIGHTS.
%
% Flags: FORWARDMODE,  NOOPEROPTIM,
%   NOLOCALCSE,  NOGLOBALCSE,  NOPRESCALARFOLDING,
%   NOPOSTSCALARFOLDING,  NOCONSTFOLDMULT0,  FUNCMODE,
%   NOTMPCLEAR,  DUMP_XML,  PARSE_ONLY,
%   UNBOUND_ERROR
%
% Parameters:
%  - dependents=z
%  - independents=a, b
%  - inputEncoding=ISO-8859-1
%  - output-mode: plain
%  - output-file: ad_out/d_adimat_sol_tril.m
%  - output-file-prefix: 
%  - output-directory: ad_out
%
% Functions in this file: d_adimat_sol_tril
%

function [d_z z] = d_adimat_sol_tril(d_a, a, d_b, b)
   [m n] = size(a);
   assert(m == n);
   tmpda1 = size(b, 2);
   z = zeros(m, tmpda1);
   d_z = d_zeros(z);
   d_z(:, 1, :) = adimat_opdiff_ediv(d_b(:, 1, :), b(1, :), d_a(:, 1, 1), a(1, 1));
   z(1, :) = b(1, :) ./ a(1, 1);
   for i=2 : n
      tmpda4 = i - 1;
      tmpda3 = i - 1;
      d_tmpca2 = adimat_opdiff_mult(d_a(:, i, 1 : tmpda3), a(i, 1 : tmpda3), d_z(:, 1 : tmpda4, :), z(1 : tmpda4, :));
      tmpca2 = a(i, 1 : tmpda3) * z(1 : tmpda4, :);
      d_tmpca1 = adimat_opdiff_sum(d_b(:, i, :), -d_tmpca2);
      tmpca1 = b(i, :) - tmpca2;
      d_z(:, i, :) = adimat_opdiff_ediv(d_tmpca1, tmpca1, d_a(:, i, i), a(i, i));
      z(i, :) = tmpca1 ./ a(i, i);
   end
end
